// grid.cpp
//

#include "stdafx.h"
#include "resource.h"
#include "lmcons.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "etc.h"


#include "os.h"
#include "wimp.h"
#include "werr.h"
#include "bbc.h"
#include "akbd.h"
#include "key.h"
#include "font.h"
#include "hourglass.h"


#include "deb.h"
#include "colour.h"
#include "key.h"
#include "wos.h"
#include "bf.h"
#include "poll.h"
#include "temp.h"
#include "osunits.h"


#include "main.h"
#include "memblock.h"
#include "dc.h"
#include "spell.h"
#include "soln.h"
#include "edit.h"
#include "mainwin.h"
#include "reslink.h"
#include "file.h"

#include "grid.h"




int xext;
int yext;


static int dragx;
static int dragy;

static int scroll_left(void);
static int scroll_right(void);
static int scroll_up(void);
static int scroll_down(void);

static int reflag;





void update_cursor(void);



void opengrid(int scx,int scy)
{
 openatscroll(gridhandle,scx,scy);
}



static void wzone(void)
{
 static int oldwidth;
 int        width;

 if(zx0!=-1)
 {
  if(zx0==zx1) width=zy0-zy1;
  else         width=zx0-zx1;

  if(width<0)  width=-width;

  if(oldwidth!=width)
  {
   writeiconf(buttonshandle,IDC_BUTTONS_ZONE,"%d",width+1);
  }
 }
 else
 {
  writeicon(buttonshandle,IDC_BUTTONS_ZONE,"");
  width=-1;
 }

 oldwidth=width;

}







static void shadedsquare(int x,int y)
{
// int i;
 int w;
 int h;

 w=meshx;
 h=meshy;

 setgcol(fillcolour);
 bbc_rectanglefilli(x,y,meshx,-meshy);

 x+=2;
 y-=4;
 w-=4;
 h-=6;
/*
 wimp_setcolour(4);

 for(i=0;i<4;i+=cvdu.deltay)
 {
  bbc_move(x,y+i);
  bbc_draw(x+w,y+i);
 }

 for(i=0;i<4;i+=cvdu.deltax)
 {
  bbc_move(x+i,y);
  bbc_draw(x+i,y-h);
 }

 wimp_setcolour(1);

 for(i=0;i<4;i+=cvdu.deltay)
 {
  bbc_move(x,y-h+i);
  bbc_draw(x+w,y-h+i);
 }

 for(i=0;i<4;i+=cvdu.deltax)
 {
  bbc_move(x+w-i,y);
  bbc_draw(x+w-i,y-h);
 }
*/

}




static os_error * gridredrawsub2(wimp_redrawstr * redrawstr)
{
 os_error  * err;
 int         bx;
 int         by;
 int         gx0;
 int         gx1;
 int         gy1;
 int         gy0;
 int         y;
 int         x;
 int         i;
 int         j;
 int         x0;
 int         x1;
 int         y0;
 int         y1;
 int         starti;
 int         startj;
 int         c;
 char        string[64];
 int         bcol;
 int         shift;
 font_metric metric;
 int         desklead;
 int         deskheight;
 int         deskfonthandle;
 int         xp;
 int         yp;


//printf("sub2");

 err=font_find_description(&textfont,&deskfonthandle);
 if(!err)
 {
           err=font_setcolour(deskfonthandle,PALTRANSPARENT,textcolour,0);
  if(!err) err=font_getmetric(&metric);
  if(!err) err=font_align(FA_CENTRE|FA_BASELINE);
  if(!err)
  {
   
   desklead=ypix2os(metric.ascent);
   deskheight=ypix2os(metric.height);

//      cprintf("sub3 %d",desklead);

   bx=redrawstr->box.x0-redrawstr->scx;
   by=redrawstr->box.y1-redrawstr->scy;

   x0=redrawstr->box.x0;
   x1=redrawstr->box.x1;
   y0=redrawstr->box.y0;
   y1=redrawstr->box.y1;

   x0=MAX(bx,x0);
   x1=MIN(bx+meshx*maxx,x1);
   y0=MAX(by-meshy*maxy,y0);
   y1=MIN(by,y1);

   if(emptycolour!=PALWHITE)
   {
    setgcol(emptycolour);
    bbc_rectanglefill(x0,y0,x1-x0,y1-y0);
   }


   gx0=((redrawstr->g.x0-bx)/meshx)*meshx+bx;
   gy1=((redrawstr->g.y1-by)/meshy)*meshy+by;
   gx1=redrawstr->g.x1;
   gy0=redrawstr->g.y0-meshy;

//   cprintf("x0=%d x1=%d",x0,x1);
//   cprintf("gx0=%d x1=%d",gx0,gx1);
//   cprintf("x0=%d x1=%d",y0,y1);
//   cprintf("gx0=%d x1=%d",gy0,gy1);


   startj=j=(-(gy1-by))/meshy;
   starti=(gx0-bx)/meshx;

   for(y=gy1;y>=(redrawstr->g.y0-meshy);j++,y-=meshy)    
   {
    i=starti;

    if(i<maxx && j<maxy)
    {
     for(x=gx0;x<redrawstr->g.x1;i++,x+=meshx)
     {
      if(i<maxx && j<maxy)
      {
       if((gridstate[i][j] & STMASK)==BLOCK)
       {
        shadedsquare(x,y);
       }
       else
       if((gridstate[i][j] & STMASK)==HILITE)
       {
        setgcol(bcol=zonecolour);
        bbc_rectanglefilli(x,y,meshx,-meshy);
       }
       else
       if(i==cursx && j==cursy)
       {
        setgcol(bcol=cursorcolour);
        bbc_rectanglefilli(x,y,meshx,-meshy);
       }
       else
       if(reflag)
       {
        setgcol(bcol=emptycolour);
        bbc_rectanglefilli(x,y,meshx,-meshy);
       }
       else
       {
        bcol=emptycolour;
       }

       if((gridstate[i][j] & STMASK)!=BLOCK)
       { 
        c=griddata[i][j];
   	    string[0]=(char)c;
	       string[1]=0;

        /* find difference between mesh width and char width */

        shift=meshy-deskheight;
        shift/=2;
        shift+=desklead;
        font_paint(string,font_ABS|font_OSCOORDS|font_BACKBLEND,x+meshx/2,y-shift);
       }

       if(gridstate[i][j] & (BLOCKX|BLOCKY))
       {
        setgcol(gridcolour);

        if(gridstate[i][j] & BLOCKY)
        {
         yp=yos2pix(y);
         bbc_move(x,ypix2os(yp-1));
         bbc_draw(x+meshx,ypix2os(yp-1));
         bbc_move(x,ypix2os(yp-2));
         bbc_draw(x+meshx,ypix2os(yp-2));
        }

        if(gridstate[i][j] & BLOCKX)
        {
         xp=xos2pix(x);
         bbc_move(xpix2os(xp+1),y);
         bbc_draw(xpix2os(xp+1),y-meshy);
         bbc_move(xpix2os(xp+2),y);
         bbc_draw(xpix2os(xp+2),y-meshy);
        }
       }
      }
     }
    }
   }

   setgcol(gridcolour);

   j=startj;
   for(y=gy1;y>=gy0 && j<=maxy;y-=meshy,j++)
   {
    bbc_move(x0,y);
    bbc_draw(x1,y);
   }

   i=starti;
   for(x=gx0;x<gx1 && i<=maxx;x+=meshx,i++)
   {
    bbc_move(x,y1);
    bbc_draw(x,y0);
   }
  }
  font_lose(deskfonthandle);
 }

 return(err);
}



static os_error * gridredrawsub(wimp_redrawstr * redrawstr,int more,int userhandle)
{
 os_error * err;

 err=NULL;

 while(more)
 {
  err=gridredrawsub2(redrawstr);
  wimp_get_rectangle(redrawstr,&more);
 }

 return(err);

 USE(userhandle);
}





static os_error * gridredraw(int handle,int userhandle)
{
 os_error       * err;
 wimp_redrawstr   redrawstr;
 int              more;

 redrawstr.w=handle;

          err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) err=gridredrawsub(&redrawstr,more,userhandle);

 return(err);
}









static void xrepaint(int x0,int y0,int x1,int y1)  /*repaints area using char vars*/
{ 
 wimp_redrawstr redrawstr;
 int            more;

 x0=x0*meshx;
 y0=-(y0*meshy);
 x1=x1*meshx;
 y1=-(y1*meshy);


 redrawstr.w=gridhandle;
 redrawstr.box.x0=x0;
 redrawstr.box.y0=y0-meshy;  
 redrawstr.box.x1=x1+meshx;
 redrawstr.box.y1=y1; 

 reflag=1;
 wimp_update_wind(&redrawstr,&more);
 gridredrawsub(&redrawstr,more,0);
 reflag=0;
}


os_error * refreshgrid(void)
{
 if(gridhandle) return(refreshwindow(gridhandle));
 return(NULL);
}



os_error * kill_cursor(void)
{
 os_error * err;
 int        xc;
 int        yc;

 xc=cursx;
 yc=cursy;
 cursx=cursy=-1;
 err=NULL;
 xrepaint(xc,yc,xc,yc);
 cursx=xc;
 cursy=yc;

 return(err);
}



void refreshcursor(void)
{
 xrepaint(cursx,cursy,cursx,cursy);
}







static void clearhilite(void)
{
 int xc0;
 int yc0;
 int xc1;
 int yc1;
 int x;
 int y;

 if(zx0<zx1)
 {
  xc0=zx0;
  xc1=zx1;
 }
 else
 {
  xc0=zx1;
  xc1=zx0;
 }

 if(zy0>zy1)
 {
  yc0=zy0;
  yc1=zy1;
 }
 else
 {
  yc0=zy1;
  yc1=zy0;
 }

 if(yc1>=0 && yc0<maxy && xc0>=0 && xc1<maxx)
 {
  for(y=yc1;y<=yc0;y++)
  {
   for(x=xc0;x<=xc1;x++)
   {
    if((gridstate[x][y] & STMASK)!=BLOCK)
    {
     gridstate[x][y]&=~STMASK;
     gridstate[x][y]|=CHARST;
    }
   }
  }
 }
}




void removezone(void)
{
 clearhilite();
 zx0=zx1=zy0=zy1=-1;
 wzone();
}




static void kill_zone(void)
{
 int xc0,yc0,xc1,yc1;

 if(zx0<zx1)
 {
  xc0=zx0;
  xc1=zx1;
 }
 else
 {
  xc0=zx1;
  xc1=zx0;
 }

 if(zy0>zy1)
 {
  yc0=zy0;
  yc1=zy1;
 }
 else
 {
  yc0=zy1;
  yc1=zy0;
 }

 removezone();
 blanksolutions();
 xrepaint(xc0,yc0,xc1,yc1);
}




void refresh_zone(void)
{
 int xc0,yc0,xc1,yc1;

 if(zx0<zx1)
 {
  xc0=zx0;
  xc1=zx1;
 }
 else
 {
  xc0=zx1;
  xc1=zx0;
 }


 if(zy0>zy1)
 {
  yc0=zy0;
  yc1=zy1;
 }
 else
 {
  yc0=zy1;
  yc1=zy0;
 }

 reflag=1;
 xrepaint(xc0,yc0,xc1,yc1);
 reflag=0;
}





void setgridextent(void)
{
 int xtent;
 int ytent;

 xtent=(maxx*meshx);
 ytent=(maxy*meshy);

 if(gridhandle) extent(gridhandle,0,-ytent,xtent,0);

 xext=xtent;
 yext=-ytent;
}







void clrgridcnt(void)
{
 int x;
 int y;

 for(x=0;x<MAXX;x++)
 {
  for(y=0;y<MAXY;y++)
  {
   gridcnt[x][y]=0;
  }
 }
}





os_error * cleargrid(void)
{
 int x,y;

 for(x=0;x<MAXX;x++)
 {
  for(y=0;y<MAXY;y++)
  {
   griddata[x][y]=32;
   gridstate[x][y]&=~(STMASK|BLOCKX|BLOCKY);
   gridstate[x][y]|=CHARST;
  }
 }

 return(NULL);
}






void cleartext(void)
{
 int x,y;

 for(x=0;x<MAXX;x++)
 {
  for(y=0;y<MAXY;y++)
  {
   if((gridstate[x][y] & STMASK)==CHARST) griddata[x][y]=32;
  }
 }
}





void randomise(void)
{
 time_t ltime;
 ltime=time(NULL);
 srand(ltime);
}















void randomgridx(void)
{
 int x;
 int y;
 int c;

 for(x=0;x<maxx;x++)
 {
  for(y=0;y<maxy;y++)
  {
   c=rand()%26;
   griddata[x][y]=(char)(c+'a');
   gridstate[x][y]&=~STMASK;
   gridstate[x][y]|=CHARST;
  }
 }
 refreshgrid();
}



/* try to fit word i into the grid */
/* random posn/direction           */
/* can it possibly fit ?           */
/* fill in word                    */
/* makegridsub(i+1) or return 1    */


int makegridsub(int i)
{
 int      x;
 int      y;
 int      sx;
 int      sy;
 int      dx;
 int      dy;
 int      nx;
 int      ny;
 int      j;
 int      k;
 int      len;
 int      r;
 int      xmask;
 wrdstr * w;

 if(i>=nsol) return(1);
 buttonssoln(i);

 sx=x=rand()%maxx;
 sy=y=rand()%maxy;
 r=rand()& 0x7;
 xmask=dmask;
 if(xmask==0) xmask=DEFWSQDIR;

 w=(wrdstr*)(sbuffer+i*sizeof(wrdstr));

 if(buttonsevent())
 {
  werr(0,"Fitted %d words, up to %s",i,w->text);
  return(1);
 }
 poll();


 len=strlen(w->text);

 while(1)
 {
  /* test all 8 ways of inserting word */

  k=r;
  while(1)
  {
   if(xmask & (1<<k))
   {
    switch(k)
    {
     case 0:
            dx=1;dy=0;
            break;
     case 1:
            dx=1;dy=1;
            break;
     case 2:
            dx=1;dy=-1;
            break;
     case 3:
            dx=0;dy=1;
            break;
     case 4:
            dx=0;dy=-1;
            break;
     case 5:
            dx=-1;dy=0;
            break;
     case 6:
            dx=-1;dy=1;
            break;
    default:
     case 7:
            dx=-1;dy=-1;
            break;
    }

   /* can it possibly fit ? */

    nx=x+(len-1)*dx;
    ny=y+(len-1)*dy;

    if(nx<maxx && nx>=0 && ny<maxy && ny>=0)
    {
    /* fill in      */
     nx=x;
     ny=y;

     for(j=0;j<len;j++)
     {
      if(griddata[nx][ny]!=w->text[j] && griddata[nx][ny]!=' ') break;
      nx+=dx;
      ny+=dy;
     }

     if(j>=len)
     {
      nx=x;
      ny=y;

      for(j=0;j<len;j++)
      {
       griddata[nx][ny]=(char)tolower(w->text[j]);
       gridcnt[nx][ny]++;
       nx+=dx;
       ny+=dy;
      }

      if(makegridsub(i+1))
      {
       w->x=x;
       w->y=y;
       w->dx=dx;
       w->dy=dy;
       return(1); /* sucess */
      }

     /* remove word  */

      nx=x;
      ny=y;

      for(j=0;j<len;j++)
      {
       gridcnt[nx][ny]--;
       if(!gridcnt[nx][ny]) griddata[nx][ny]=' ';
       nx+=dx;
       ny+=dy;
      }
     }
    }
   }
   k++;
   if(k>=8) k=0;
   if(k==r) break;
  }

  x++;
  if(x>=maxx)
  {
   x=0;
   y++;
   if(y>=maxy) y=0;
  }

  if(x==sx && y==sy) return(0); /* failed */
 }
}



void initgrid(void)
{
 int x;
 int y;

 for(x=0;x<maxx;x++)
 {
  for(y=0;y<maxy;y++)
  {
   griddata[x][y]=' ';
   gridstate[x][y]&=~STMASK;
   gridstate[x][y]|=CHARST;
   gridcnt[x][y]=0;
  }
 }
}


void fillspaces(void)
{
 int x;
 int y;

 for(x=0;x<maxx;x++)
 {
  for(y=0;y<maxy;y++)
  {
   if(griddata[x][y]==' ') griddata[x][y]=(char)((rand()%26)+'a');
  }
 }
}




int gxlo;
int gxhi;
int gylo;
int gyhi;


void gridstartredraw(void)
{
 gxlo=gxhi=gylo=gyhi=-1;
}


void gridaddredraw(wrdstr * w)
{
 int len;
 int xlo;
 int xhi;
 int ylo;
 int yhi;

 if(w->x>=0 && w->x<maxx && w->y>=0 && w->y<maxy)
 {
  len=strlen(w->text)-1;

  if(w->dx>0)
  {
   xlo=w->x;
   xhi=xlo+w->dx*len;
  }
  else
  {
   xhi=w->x;
   xlo=xhi+w->dx*len;
  }

  if(w->dy>0)
  {
   ylo=w->y;
   yhi=ylo+w->dy*len;
  }
  else
  {
   yhi=w->y;
   ylo=yhi+w->dy*len;
  }


  if(gxlo==-1)
  {
   gxlo=xlo;
   gylo=ylo;
   gxhi=xhi;
   gyhi=yhi;
  }
  else
  {
   gxlo=MIN(gxlo,xlo);
   gxhi=MAX(gxhi,xhi);
   gylo=MIN(gylo,ylo);
   gyhi=MAX(gyhi,yhi);
  }
 }
}


void gridendredraw(void)
{

/* dprintf(0,"xlo=%d xhi=%d ylo=%d yhi=%d",gxlo,gxhi,gylo,gyhi); */

 if(gxlo!=-1) xrepaint(gxlo,gyhi,gxhi,gylo);
}



void gridclrword(wrdstr * w)
{
 int x;
 int y;
 int i;
 int len;

 len=strlen(w->text);
 x=w->x;
 y=w->y;
 for(i=0;i<len;i++)
 {
  if(x<0 || y<0) break;
  if(!(--gridcnt[x][y])) gridstate[x][y]=CHARST;
  x+=w->dx;
  y+=w->dy;
 }
}


void gridsetword(wrdstr * w)
{
 int x;
 int y;
 int i;
 int len;

 len=strlen(w->text);
 x=w->x;
 y=w->y;

 for(i=0;i<len;i++)
 {
  if(x<0 || y<0) break;
  if(!(gridcnt[x][y]++)) gridstate[x][y]=HILITE;
  x+=w->dx;
  y+=w->dy;
 }
}







void clearselection(void)
{
 wrdstr * w;
 int      i;

 w=(wrdstr*)(sbuffer);

 for(i=0;i<nsol;i++)
 {
  if(w->selected)
  {
   gridaddredraw(w);
   gridclrword(w);
  }
  w->selected=0;
  w++;
 }
}


void clearselectionhi(void)
{
 if(nselectedsquare())
 {
  gridstartredraw();
  clearselection();
  gridendredraw();
  refreshsols();
 }
}



/* use wrdstr's to make a grid */


static void szero(int userhandle)
{
 USE(userhandle);
}


static void scallbackmakesq(int userhandle)
{

 buttonssolve(1);
 hourglasson();
 addzeroevent(szero,0);

 makegridsub(0);

 remzeroevent(szero,0);
 hourglassoff();
 buttonssolve(0);

 fillspaces();
 clrgridcnt();
 refreshgrid();

 USE(userhandle);
}



os_error * makegrid(void)
{
 clearselectionhi();
 initgrid();
 clearsquaresolnscoords();

 addscheduledevent(scallbackmakesq,0,10);

 refreshgrid();
 modfile();

 return(NULL);
}


static void scallbackrandom(int userhandle)
{
 char       string[STRLEN];
 int        attempts;

 buttonssolve(1);
 hourglasson();
 addzeroevent(szero,0);

 attempts=3;
 randomwordstart();

 while(1)
 {
  randomword(string);
  addsquaresolution(-1,-1,-1,-1,string);
  if(!makegridsub(nsol-1) && !attempts--) break;
  if(buttonsevent()) break;
 }

 remzeroevent(szero,0);
 hourglassoff();
 buttonssolve(0);

 fillspaces();
 clearsolutions();
 opensol();
 setsolextent();
 refreshsols();

 refreshgrid();

 USE(userhandle);
}



os_error * randomgrid(void)
{
 os_error * err;

 err=checkfiledc();
 if(!err)
 {
  initgrid();
  clearsolutions();

  addscheduledevent(scallbackrandom,0,10);

  opensol();
  setsolextent();
  refreshsols();

  refreshgrid();
  modfile();
 }

 return(err);
}









void setsize(int x,int y)
{
 if(x<MAXX) maxx=x;
 else       maxx=MAXX-1;

 if(y<MAXY) maxy=y;
 else       maxy=MAXY-1;

 setgridextent();
 removezone();
 blanksolutions();
 refreshgrid();
 modfile();
}



os_error * clear_screen(void)
{
 os_error * err;

 err=NULL;

 cleargrid();
 removezone();
 blanksolutions();
 refreshgrid();
 unmodfile();
 setgridname("");

 return(err);
}



os_error * clear_words(void)
{
 os_error * err;

 err=NULL;
 
 removezone();
 blanksolutions();
 cleartext();
 refreshgrid();
 modfile();

 return(err);
}


int gridcasechar(int ch)
{
 if(gridcase==1) return(toupper(ch));
 else
 if(gridcase==2) return(tolower(ch));
 else            return(ch);
}





static os_error * checkgridcase(void)
{
 int x,y;

 removezone();
 blanksolutions();
 modfile();

 for(x=0;x<MAXX;x++)
 {
  for(y=0;y<MAXY;y++)
  {
   if((gridstate[x][y] & STMASK)==CHARST)
   {
    griddata[x][y]=(char)gridcasechar(griddata[x][y]);
   }
  }
 }

 return(refreshgrid());
}


os_error * setgriduppercase(void)
{
 gridcase&=~0x2;
 gridcase^=1;
 return(checkgridcase());
}



os_error * setgridlowercase(void)
{
 gridcase&=~0x1;
 gridcase^=2;
 return(checkgridcase());
}







/************************************************************************************/




void calczonesize(void)
{
 int x;
 int y;

 zx0=zx1=zy0=zy1=-1;

 for(x=0;x<maxx;x++)
 {
  for(y=0;y<maxy;y++)
  {
   if((gridstate[x][y] & STMASK)==HILITE)
   {
    if(zx0==-1)
    {
     zx0=zx1=x;
     zy0=zy1=y;
    }
    else
    {
     if(x<zx0) zx0=x;
     if(x>zx1) zx1=x;
     if(y<zy1) zy1=y;
     if(y>zy0) zy0=y;
    }
   }
  }
 }
}




static int dragfromcursorstate;


// cursx,cursy always hold start of drag box
// we xor marked state of change in area


static os_error * griddrag(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        x;
 int        y;
 int        changed;
 int        xmin=0;
 int        xmax=0;
 int        ymin=0;
 int        ymax=0;
 int        lox;
 int        hix;
 int        loy;
 int        hiy;
 int        ix;
 int        iy;
 int        x0;
 int        x1;
 int        y0;
 int        y1;
 int        znew;
 int        zold;
 windowstr  window;


 err=getw(handle,&window);
 x=(m->x-window.x0+window.scx)/meshx;
 y=(-window.scy+window.y1-m->y-4)/meshy;

 if(x<0) x=0;
 if(x>=maxx) x=maxx-1;
 if(y<0) y=0;
 if(y>=maxy) y=maxy-1;

// if(x!=cursx || y!=cursy)
 {

  // old area zx0,zx1,zy0,zy1 ordered
  // new area dragx,x,dragy,y

  x0=MIN(x,dragx);
  x1=MAX(x,dragx);
  y1=MIN(y,dragy);
  y0=MAX(y,dragy);

  if(zx0>=0)
  {
   lox=MIN(x0,zx0);
   hix=MAX(x1,zx1);
   loy=MIN(y1,zy1);
   hiy=MAX(y0,zy0);
  }
  else
  {
   lox=x0;
   hix=x1;
   loy=y1;
   hiy=y0;
  }

  changed=0;

  for(iy=loy;iy<=hiy;iy++)
  {
   for(ix=lox;ix<=hix;ix++)
   {
    zold=(ix>=zx0 && ix<=zx1 && iy>=zy1 && iy<=zy0);
    znew=(ix>=x0 && ix<=x1 && iy>=y1 && iy<=y0);

    if(zold!=znew)
    {
     if((gridstate[ix][iy] & STMASK)!=BLOCK)
     {
      if(!changed)
      {
       xmin=xmax=ix;
       ymin=ymax=iy;
       changed=1;
      }
      else
      {
       xmin=MIN(xmin,ix);
       xmax=MAX(xmax,ix);
       ymin=MIN(ymin,iy);
       ymax=MAX(ymax,iy);
      }

      gridstate[ix][iy]^=HILITE;
     }
    }
   }
  }

  zx0=x0;
  zx1=x1;
  zy1=y1;
  zy0=y0;

  if(dragfromcursorstate)
  {
   if(x0==x1 && y0==y1)
   {
    cursx=x0;
    cursy=y0;
    zx0=zx1=-1;
    zy0=zy1=-1;
    gridstate[x0][y0]&=~HILITE;
   }
   else
   {
    cursx=cursy=-1;
   }
  }

  if(changed)
  {
   xrepaint(xmin,ymax,xmax,ymin);
  }

  wzone();
 }


 if(m->x>(window.x1-meshx)) scroll_right();
 if(m->x<(window.x0+meshx)) scroll_left();
 if(m->y<(window.y0+meshy)) scroll_down();
 if(m->y>(window.y1-meshy)) scroll_up();

 return(NULL);

 USE(userhandle);
}




static os_error * griddragend(int handle,int userhandle,wimp_box * box)
{
 dragfromcursorstate=0;
 calczonesize();
 wzone();

 return(NULL);

 USE(handle);
 USE(userhandle);
 USE(box);
}






static void toggleblock(int x,int y)
{
 if((gridstate[x][y] & STMASK)==BLOCK)
 {
  griddata[x][y]=32;
  gridstate[x][y]&=~(STMASK|BLOCKX|BLOCKY);
  gridstate[x][y]|=CHARST;
 }
 else
 {
  gridstate[x][y]&=~STMASK;


  if(isshift) gridstate[x][y]^=BLOCKX;
  else
  if(isctrl)  gridstate[x][y]^=BLOCKY;
  else        gridstate[x][y]|=BLOCK;
 }
 xrepaint(x,y,x,y);
}







static os_error * gridclick(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        x;
 int        y;
 windowstr  window;

 err=setfocus(gridhandle);

 getw(handle,&window);
 x=(m->x-window.x0+window.scx)/meshx;
 y=(-window.scy+window.y1-m->y-4)/meshy;


 if(x>=0 && x<maxx && y>=0 && y<maxy)
 {
  if(m->bbits==0x1)                    /* adjust click */
  {
   if(gridtype==CROSSTYPE)
   {
    if(zx0!=-1)
    {
     if((gridstate[x][y] & STMASK)!=BLOCK)
     {
      if((gridstate[x][y] & STMASK)==HILITE)
      {
       gridstate[x][y]&=~STMASK;
       gridstate[x][y]|=CHARST;
      }
      else
      {
       gridstate[x][y]&=~STMASK;
       gridstate[x][y]|=HILITE;
      }
      modfile();
      xrepaint(x,y,x,y);
      calczonesize();
      blanksolutions();
     }
    }
    else
    {
     toggleblock(x,y);
     modfile();
    }
   }
  }
  else
  if(m->bbits==0x4)                  /* select click - home cursor */
  {
   if(zx0!=-1 && isctrl)
   {


   }
   else
   {
    if(zx0!=-1) kill_zone();

    if((gridstate[x][y] & STMASK)==BLOCK) bbc_vdu(7);
    else
    {
     if(cursx!=-1 && cursy!=-1) kill_cursor();
     cursx=x;
     cursy=y;
     update_cursor();

     refreshcursor();
    }
   }
  }
  else
  if(m->bbits==0x40)                   /* select drag - start zone */
  {
   wimp_dragstr drg;

   if(gridtype==CROSSTYPE)
   {
    getw(gridhandle,&window);

    drg.window=gridhandle;
    drg.type=wimp_USER_HIDDEN;
    drg.box.x0=m->x;
    drg.box.y0=m->y;
    drg.box.x1=m->x;
    drg.box.y1=m->y;
    drg.parent.x0=window.x0-2*cvdu.deltax;
    drg.parent.y0=window.y0-2*cvdu.deltay;
    drg.parent.x1=window.x1+2*cvdu.deltax;
    drg.parent.y1=window.y1+2*cvdu.deltay;

    wimp_drag_box(&drg);

    dragx=x;
    dragy=y;
    dragfromcursorstate=(zx0==-1);

    zx0=zx1=-1;
    zy0=zy1=-1;

    if(!dragfromcursorstate) griddrag(gridhandle,0,m);
    startdrag2(gridhandle,0,griddragend,griddrag);
   }
  }
 }
 else
 {
  if(m->bbits==0x4 || m->bbits==0x1) bbc_vdu(7);
 }
     
 return(NULL);

 USE(userhandle);
}




/**************************************************************************************/




void update_cursor(void)
{
 lcursx=cursx;
 lcursy=cursy;
}




void removecursor(void)
{
 cursx=cursy=-1;
 update_cursor();
}





void cursor_left(void)
{
 int i;
 windowstr window;
 /* scan left until find good square */

 for(i=cursx-1;i>-1;i--)
    if((gridstate[i][cursy] & STMASK)!=BLOCK) break;

 if(i==-1) return;

 getw(gridhandle,&window);
 if(i*meshx<window.scx) opengrid(i*meshx,window.scy);

 kill_cursor();
 update_cursor();
 cursx=i;
 refreshcursor();
}







void cursor_right(void)
{
 int i;
 int wext;
 windowstr window;

 for(i=cursx+1;i<maxx;i++)
    if((gridstate[i][cursy] & STMASK)!=BLOCK) break;
 if(i==maxx) return;

 getw(gridhandle,&window);
 wext=window.x1-window.x0;
 if((i*meshx)>(window.scx+wext-meshx)) opengrid((i+1)*meshx-wext,window.scy);

 kill_cursor();
 update_cursor();
 cursx=i;
 refreshcursor();
}








void cursor_up(void)
{
 int i;
 windowstr window;

 for(i=cursy-1;i>-1;i--)
    if((gridstate[cursx][i] & STMASK)!=BLOCK) break;
  if(i==-1) return;

 getw(gridhandle,&window);
 if(i*meshy<-window.scy) opengrid(window.scx,-i*meshy);

 kill_cursor();
 update_cursor();
 cursy=i;
 refreshcursor();
}





void cursor_down(void)
{
 int i;
 int wext;
 windowstr window;

 for(i=cursy+1;i<maxy;i++)
    if((gridstate[cursx][i] & STMASK)!=BLOCK) break;

 if(i==maxy) return;

 getw(gridhandle,&window);
 wext=window.y1-window.y0;
 if((i*meshy)>=(-window.scy+wext-meshy)) opengrid(window.scx,-(i+1)*meshy+wext);

 kill_cursor();
 update_cursor();
 cursy=i;
 refreshcursor();
}





void shift_cursor(void)
{
 int right;
 int down;
 int wextx;
 int wexty;
 windowstr window;

 right=((cursx+1)<maxx && 
        (gridstate[cursx+1][cursy] & STMASK)!=BLOCK &&
        !(gridstate[cursx+1][cursy] & BLOCKX)
       );

 down =((cursy+1)<maxy && 
        (gridstate[cursx][cursy+1] & STMASK)!=BLOCK &&
        !(gridstate[cursx][cursy+1] & BLOCKY)
       );

 getw(gridhandle,&window);
 wextx=window.x1-window.x0;
 wexty=window.y1-window.y0;

 if((cursx==(lcursx+1) && cursy==lcursy && right) || (right && !down))
 {
  update_cursor();
  cursx++;
  if((cursx*meshx)>(window.scx+wextx-meshx)) opengrid((cursx+1)*meshx-wextx,window.scy);
 }
 else
 if((cursy==(lcursy+1) && cursx==lcursx && down)  || (down  && !right))
 {
  update_cursor();
  cursy++;
  if((cursy*meshy)>=(-window.scy+wexty-meshy)) opengrid(window.scx,-(cursy+1)*meshy+wexty);
 }
 else 
  bbc_vdu(7);
}






void back_cursor(void)
{
 int left,up;
 windowstr window;

 left=((cursx-1)>-1 && (gridstate[cursx-1][cursy] & STMASK)!=BLOCK);
 up  =((cursy-1)>-1 && (gridstate[cursx][cursy-1] & STMASK)!=BLOCK);

 getw(gridhandle,&window);

 if((cursx==(lcursx-1) && cursy==lcursy && left) || (left && !up))
 {
  update_cursor();
  cursx--;
  if(cursx*meshx<window.scx) opengrid(cursx*meshx,window.scy);
 }
 else
 if((cursy==(lcursy-1) && cursx==lcursx && up) || (up && !left))
 {
  update_cursor();
  cursy--;
  if(cursy*meshy<-window.scy)  opengrid(window.scx,-cursy*meshy);
 }
 else 
  bbc_vdu(7);
}






int scroll_left(void)
{
 int tsc;
 windowstr window;

 getw(gridhandle,&window);
 tsc=window.scx;
 if(window.scx==0) return(0);
 opengrid(window.scx-meshx,window.scy);
 getw(gridhandle,&window);
 return(!(window.scx==tsc));
}






int scroll_right(void)
{
 int tsc;
 int wext;
 windowstr window;

 getw(gridhandle,&window);
 wext=window.x1-window.x0;
 tsc=window.scx;
 if(window.scx==xext-wext) return(0);
 opengrid(window.scx+meshx,window.scy);
 getw(gridhandle,&window);
 return(!(window.scx==tsc));
}







int scroll_up(void)
{
 int tsc;
 windowstr window;

 getw(gridhandle,&window);
 tsc=window.scy;
 if(window.scy==0) return(0);
 opengrid(window.scx,window.scy+meshy);
 getw(gridhandle,&window);
 return(!(window.scy==tsc));
}





int scroll_down(void)
{
 int tsc;
 int wext;
 windowstr window;

 getw(gridhandle,&window);
 wext=window.y1-window.y0;
 tsc=window.scy;
 if(window.scy==yext+wext) return(0);
 opengrid(window.scx,window.scy-meshy);
 return(!(window.scy==tsc));
}




os_error * reflecthoriz(void)
{
 os_error * err;
 int x;
 int y;
 int s;
 int o;

 err=NULL;

 removezone();
 blanksolutions();

 for(x=0;x<(maxx-1)/2;x++)
 {
  for(y=0;y<maxy;y++)
  {
   s=gridstate[x][y] &(BLOCKX);
   o=gridstate[maxx-1-x][maxy-1-y] & (BLOCKX);

   gridstate[maxx-1-x][y]=(char)(gridstate[x][y] & (~(BLOCKX)));
   gridstate[maxx-1-x][y]=(char)(gridstate[maxx-1-x][y] | o);

   gridstate[maxx-x][y]=(char)((gridstate[maxx-x][y] & (~(BLOCKX))) | s);
  }
 }

 refreshgrid();
 modfile();

 return(err);
}






os_error * reflectvert(void)
{
 os_error * err;
 int x;
 int y;
 int s;
 int o;

 err=NULL;

 removezone();
 blanksolutions();

 for(y=0;y<(maxy-1)/2;y++)
 {
  for(x=0;x<maxx;x++)
  {
   s=gridstate[x][y] &(BLOCKY);
   o=gridstate[maxx-1-x][maxy-1-y] & (BLOCKY);

   gridstate[x][maxy-1-y]=(char)(gridstate[x][y] & (~(BLOCKY)));
   gridstate[x][maxy-1-y]=(char)(gridstate[x][maxy-1-y] | o);

   gridstate[x][maxy-y]=(char)((gridstate[x][maxy-y] & (~(BLOCKY))) | s);
  }
 }
 refreshgrid();
 modfile();

 return(err);
}




/* reflect in / diag */

os_error * reflectdiag1(void)
{
 os_error * err;
 int x;
 int y;
 int xlimit;
 int s;
 int o;

 err=NULL;

 removezone();
 blanksolutions();

 for(y=0;y<maxy;y++)
 {
  xlimit=(maxx*(maxy-y))/maxy;

  for(x=0;x<xlimit;x++)
  {
   s=gridstate[x][y] & (BLOCKX|BLOCKY);
   o=gridstate[maxx-1-x][maxy-1-y] & (BLOCKX|BLOCKY);

   gridstate[maxx-1-x][maxy-1-y]=(char)(gridstate[x][y] & (~(BLOCKX|BLOCKY)));
   gridstate[maxx-1-x][maxy-1-y]=(char)(gridstate[maxx-1-x][maxy-1-y] | o);

   gridstate[maxx-1-x][maxy-y]=(char)
                ((gridstate[maxx-1-x][maxy-y] & (~(BLOCKY))) | (s & BLOCKY));

   gridstate[maxx-x][maxy-1-y]=(char)
                ((gridstate[maxx-x][maxy-1-y] & (~(BLOCKX))) | (s & BLOCKX));
  }
 }

 refreshgrid();
 modfile();

 return(err);
}



/* reflect in \ diag */

os_error * reflectdiag2(void)
{
 os_error * err;
 int x;
 int y;
 int xlimit;
 int s;
 int o;

 err=NULL;
 
 removezone();
 blanksolutions();

 for(y=0;y<maxy;y++)
 {
  xlimit=(maxx*y)/maxy;

  for(x=maxx-1;x>=xlimit;x--)
  {
   s=gridstate[x][y] & (BLOCKX|BLOCKY);
   o=gridstate[maxx-1-x][maxy-1-y] & (BLOCKX|BLOCKY);

   gridstate[maxx-1-x][maxy-1-y]=(char)(gridstate[x][y] & (~(BLOCKX|BLOCKY)));
   gridstate[maxx-1-x][maxy-1-y]=(char)(gridstate[maxx-1-x][maxy-1-y] | o);

   gridstate[maxx-1-x][maxy-y]=(char)
                ((gridstate[maxx-1-x][maxy-y] & (~(BLOCKY))) | (s & BLOCKY));

   gridstate[maxx-x][maxy-1-y]=(char)
                ((gridstate[maxx-x][maxy-1-y] & (~(BLOCKX))) | (s & BLOCKX));
  }
 }

 refreshgrid();
 modfile();

 return(err);
}







static os_error * gridkey(int handle,int userhandle,int icon,int * key)
{
 os_error * err;
 int ch=*key;

 err=NULL;

// cprintf("grid key %x",ch);

 switch(ch)
 {
     case CTRL_S:
             err=savecurrentgrid();
             break;

     case F5: 
             err=reflectvert();
                break;

     case F6:
             err=reflecthoriz();
                break;

     case F7:
             err=reflectdiag1();
                break;

     case F8:
             err=reflectdiag2();
                break;

     case CLEFT:
                cursor_left();
                break;

     case CRIGHT:
                cursor_right();
                break;

     case CDOWN:
                cursor_down();
                break;

     case CUP:
                cursor_up();
                break;

     case SHFT_CRIGHT:
                scroll_right();
                break;

     case SHFT_CLEFT:
                scroll_left();
                break;

     case SHFT_CDOWN:
                scroll_down();
                break;

     case SHFT_CUP:
                scroll_up();
                break;

     case       DEL:
     case BACKSPACE:
                griddata[cursx][cursy]=32;
                kill_cursor();
                back_cursor();
                refreshcursor();
                modfile();
                break;

// letting space toggle blocks is not a good idea because cursor
// can't move into blocks

     case ESCAPE:
                 buttonssetevent();
                 break;

        default:
                if(!(ch & KEYVIRT))
                {
                 ch=(char)gridcasechar(ch);

                 if(ch==' ' || isalpha(ch) || ch=='*')
                 {
                  griddata[cursx][cursy]=(char)ch;
                  kill_cursor();
                  shift_cursor();
                  refreshcursor();
                  modfile();
                 }
                }
                else
                {
                 return(NULL);
                }
                break;
 }

 *key=-1;
 
 return(err);

 USE(icon);
 USE(userhandle);
 USE(handle);
}







os_error * gridinit(int mainhandle)
{
 os_error * err;
 
 err=createwindowparent(TGRID,&gridhandle,mainhandle);
 if(!err)
 {
  wimp_setwindowbackground(gridhandle,CCRGB|PALWHITE);
  wimp_setwindowflags(gridhandle,WINDOWFIXED|WINDOWNOTDIALOGUE,0);
  addredrawevent(gridredraw,gridhandle,0);
  adddataload(gridhandle,0,loadgridv);
  adddataloadpost(gridhandle,0,loadgridpostv);
  adddataloadtype(gridhandle,0,loadgridtypev);
  addclickevent(gridclick,gridhandle,0);
  addkeyevent(gridkey,mainhandle,0);
  addkeyevent(gridkey,gridhandle,0);

  setgridextent();

  randomise();
 }
 return(err);
}


