/*->c.main */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "font.h"

#include "wos.h"
#include "err.h"
#include "task.h"
#include "poll.h"
#include "temp.h"
#include "scrap.h"
#include "fsx.h"
#include "conf.h"
#include "etc.h"
#include "flex.h"
#include "sp.h"
#include "deb.h"
#include "appinfo.h"
#include "appreg.h"
#include "mlo.h"
#include "osunits.h"
#include "colour.h"
#include "xmath.h"
#include "bf.h"
#include "oshelp.h"


#include "resource.h"

#include "constants.h"

#include "reslink.h"
#include "mainwin.h"
#include "memblock.h"
#include "dc.h"
#include "spell.h"
#include "edit.h"
#include "soln.h"
#include "grid.h"
#include "file.h"
#include "cxchoices.h"

#include "main.h"


int    version=220;
int    compatability=0;
char * datestring="(02-Feb-2018)";


char * programdir="<HKEY_LOCAL_MACHINE\\Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\CrossStar.exe\\Path>\\";
char * dictionarydir="<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\Dictionaries\\>";


void terminate(void)
{
 event(EVENT_ENDPROGRAM,NULL,0);
 flex_finit();
 exit(0);
}




static os_error * terminatemessage(wimp_msgstr * msg,int * ack)
{
 terminate();
 USE(msg);
 USE(ack);
 return(NULL);
}



int unsaved(void)
{
 if(filemodded()) return(1);
 return(0);
}




/* return 1 if not to quit */

int termnok(void)
{
 int n=unsaved();
 int code;

 if(n)
 {
  if(n==1) messageboxquery(mainhandle,MQYN|MQWARN,&code,"{FS10}");
  else     messageboxquery(mainhandle,MQYN|MQWARN,&code,"%d {FS09}");

  if(code!=MQRY) return(1);
 }

 return(0);
}


/* set ack to 1 if you want to stop the quit sequence */

/*

static os_error * prequithandler(int userhandle,int * ack,int prequit) 
{
 if(prequit==1)
 {
  if(unsaved()) *ack=1;
 }
 else
 {
  if(termnok()) *ack=1;
  else
  {

  
  }
 }
 return(NULL);

 USE(userhandle);
}

*/

static os_error * addmessages(void)
{
 os_error * err;

          err=addmessage(terminatemessage,wimp_MCLOSEDOWN);
// if(!err) err=addprequit(prequithandler,0);

 return(err);
}




static os_error * appregevent(int handle,int event)
{
 os_error * err;

 err=NULL;

 switch(event)
 {

 case APPREGDOC:
                helptopic(mainhandle,"<HKEY_LOCAL_MACHINE\\Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\DPTrace.exe\\Path>\\Trace.chm::/registration.htm>");
                break;

 }

 return(err);

 USE(handle);
}




static void crashcleanup(void)
{
 flex_finit();
}



static os_error * initprogram(void)
{
 os_error * err;
 
          err=initsp();
 if(!err) err=editinit();
 if(!err) err=cleargrid();
 if(!err) err=loadchoices();
 if(!err) err=loaddefaultgrid();

 return(err);
}




static int productcodes[]=
{
 APPREGCROSSXCODE,
 APPREGCROSSXSLCODE,
 APPREGLASTCODE
};



int main(int argc,char * argv[])
{ 
 os_error * err;

 setlocale(LC_ALL,".1252");

 err=inittask("CrossStar","CrossStar","!CrossStar",NULL,NULL,NULL);
// if(!err) err=appreginit(appregevent,productcodes);

 if(err)
 {
  report(err);
  exit(0);
 }


// debugenable(crashcleanup);

 wimpt_setcrash(crashcleanup);


 if(!err) err=resinit(NULL);

 if(!err) err=addmessages();

 if(!err) err=initprogram();


 event(EVENT_RUNPROGRAM,NULL,0);

 err=openmainwindow();
 if(!err) err=appreg(mainhandle);

 if(err)
 {
  report(err);
  terminate();
 }

 if(argc==2) report(loadgrid(argv[1],CXFTYPE,0,0));


 runtask();

 return(0);
}


